summaryrefslogtreecommitdiffstats
path: root/development/bbcsdl
diff options
context:
space:
mode:
author Antonio Leal2023-09-01 16:58:51 +0200
committer Willy Sudiarto Raharjo2023-09-01 16:58:51 +0200
commit49f07dcd735321412a12c60518caa37e735a1944 (patch)
treeb4a2f14eb96794b04725f093bfc358fbe9b8c69a /development/bbcsdl
parent98000ba4228bfc6e73e057988730a3d90f6fdae2 (diff)
downloadslackbuilds-49f07dcd735321412a12c60518caa37e735a1944.tar.gz
development/bbcsdl: Added (BBC BASIC for Linux).
Signed-off-by: Willy Sudiarto Raharjo <willysr@slackbuilds.org>
Diffstat (limited to 'development/bbcsdl')
-rw-r--r--development/bbcsdl/README26
-rw-r--r--development/bbcsdl/bbc256x.pngbin0 -> 2172 bytes
-rw-r--r--development/bbcsdl/bbcsdl.SlackBuild116
-rw-r--r--development/bbcsdl/bbcsdl.desktop10
-rw-r--r--development/bbcsdl/bbcsdl.info12
-rw-r--r--development/bbcsdl/doinst.sh13
-rw-r--r--development/bbcsdl/slack-desc19
7 files changed, 196 insertions, 0 deletions
diff --git a/development/bbcsdl/README b/development/bbcsdl/README
new file mode 100644
index 0000000000..5e05821260
--- /dev/null
+++ b/development/bbcsdl/README
@@ -0,0 +1,26 @@
+BBC BASIC for SDL 2.0 (BBCSDL) is an entirely free and Open Source
+cross-platform implementation of BBC BASIC for Windows, MacOS,
+Linux (x86 CPU only), Raspberry Pi OS (RPi3 or later), Android,
+iOS or for running in a browser.
+It combines the simplicity of BASIC with the sophistication of a
+structured language, allowing you to write utilities and games,
+use sound and graphics, and perform calculations.
+The Desktop editions (Windows, MacOS, Linux, Raspberry Pi)
+include a BASIC program editor with syntax colouring, live
+indentation, search & replace and many other features.
+Built-in diagnostic aids such as run-time trace, listing of
+variables, single-step execution and a profiler make debugging
+even the most complex programs straightforward.
+
+This package installs to /opt/bbcsdl and is a rebuild of the open
+sources available at https://github.com/rtrussell/BBCSDL
+
+The Box2D321.so library (md5 215bbda5d9a92a5cc99534de4e1235aa)
+is bundled with the original release by R.T.Russell available
+at https://www.bbcbasic.co.uk/bbcsdl/bbclinux.zip
+This SlackBuild includes it as a separate download from the
+package maintainer github account as it is not packaged with
+program sources. You can safely delete it if you are not
+writing 2D graphics program simulating physics.
+
+Many examples at /opt/bbcsdl/examples/
diff --git a/development/bbcsdl/bbc256x.png b/development/bbcsdl/bbc256x.png
new file mode 100644
index 0000000000..2c2cd13d9e
--- /dev/null
+++ b/development/bbcsdl/bbc256x.png
Binary files differ
diff --git a/development/bbcsdl/bbcsdl.SlackBuild b/development/bbcsdl/bbcsdl.SlackBuild
new file mode 100644
index 0000000000..6bc162cfb5
--- /dev/null
+++ b/development/bbcsdl/bbcsdl.SlackBuild
@@ -0,0 +1,116 @@
+#!/bin/bash
+
+# Slackware build script for bbcsdl
+
+# Copyright 2023 Antonio Leal, Porto Salvo, Oeiras, Portugal
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR "AS IS" AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+
+cd $(dirname $0) ; CWD=$(pwd)
+
+PRGNAM=bbcsdl
+VERSION=${VERSION:-1.36a}
+BUILD=${BUILD:-1}
+TAG=${TAG:-_SBo}
+PKGTYPE=${PKGTYPE:-tgz}
+TARBALL=${TARBALL:-BBCSDL-ae588d80bc303897b5da5e108863e0c07fdb30d8}
+
+if [ -z "$ARCH" ]; then
+ case "$( uname -m )" in
+ i?86) ARCH=i586 ;;
+ arm*) ARCH=arm ;;
+ *) ARCH=$( uname -m ) ;;
+ esac
+fi
+
+if [ ! -z "${PRINT_PACKAGE_NAME}" ]; then
+ echo "$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.$PKGTYPE"
+ exit 0
+fi
+
+TMP=${TMP:-/tmp/SBo}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+if [ "$ARCH" = "i586" ]; then
+ SLKCFLAGS="-O2 -march=i586 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "i686" ]; then
+ SLKCFLAGS="-O2 -march=i686 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "x86_64" ]; then
+ SLKCFLAGS="-O2 -fPIC"
+ LIBDIRSUFFIX="64"
+else
+ SLKCFLAGS="-O2"
+ LIBDIRSUFFIX=""
+fi
+
+set -e
+rm -rf $PKG
+mkdir -p $TMP $PKG $OUTPUT
+cd $TMP
+rm -rf $PRGNAM-$VERSION
+tar xvfz $CWD/$TARBALL.tar.gz
+mv $TARBALL $PRGNAM-$VERSION
+cd $PRGNAM-$VERSION
+tar xvfz $CWD/Box2D231.tar.gz
+
+chown -R root:root .
+find -L . \
+ \( -perm 777 -o -perm 775 -o -perm 750 -o -perm 711 -o -perm 555 \
+ -o -perm 511 \) -exec chmod 755 {} \; -o \
+ \( -perm 666 -o -perm 664 -o -perm 640 -o -perm 600 -o -perm 444 \
+ -o -perm 440 -o -perm 400 \) -exec chmod 644 {} \;
+
+cd bin/linux
+make
+cd ../..
+
+mkdir -p $PKG/usr/bin $PKG/opt/$PRGNAM $PKG/usr/share/pixmaps $PKG/usr/share/applications
+
+install -D -m0755 bbcsdl $PKG/opt/$PRGNAM/bbcsdl
+install -D -m0755 libstb.so $PKG/opt/$PRGNAM/libstb.so
+install -D -m0755 Box2D231.so $PKG/opt/$PRGNAM/Box2D231.so
+cp bbcsdl.bbc $PKG/opt/$PRGNAM/
+
+cp -avxu lib $PKG/opt/$PRGNAM/
+cp -avxu examples $PKG/opt/$PRGNAM/
+
+cp $CWD/bbc256x.png $PKG/usr/share/pixmaps
+cp $CWD/bbcsdl.desktop $PKG/usr/share/applications
+
+( cd $PKG/usr/bin ; rm -rf bbcsdl )
+( cd $PKG/usr/bin ; ln -s /opt/bbcsdl/bbcsdl bbcsdl )
+
+find $PKG -print0 | xargs -0 file | grep -e "executable" -e "shared object" | grep ELF \
+ | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
+
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
+cat $CWD/$PRGNAM.SlackBuild > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
+cp licence.txt $PKG/usr/doc/$PRGNAM-$VERSION
+cp README.md $PKG/usr/doc/$PRGNAM-$VERSION
+
+mkdir -p $PKG/install
+cat $CWD/slack-desc > $PKG/install/slack-desc
+cat $CWD/doinst.sh > $PKG/install/doinst.sh
+
+cd $PKG
+/sbin/makepkg -l y -c n $OUTPUT/$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.$PKGTYPE
diff --git a/development/bbcsdl/bbcsdl.desktop b/development/bbcsdl/bbcsdl.desktop
new file mode 100644
index 0000000000..6f1ee9f081
--- /dev/null
+++ b/development/bbcsdl/bbcsdl.desktop
@@ -0,0 +1,10 @@
+[Desktop Entry]
+Name=BBC BASIC
+GenericName=BBC BASIC
+Comment=BBC BASIC for Linux
+Icon=bbc256x
+Exec=bbcsdl
+Type=Application
+Terminal=false
+Categories=Development
+StartupNotify=false
diff --git a/development/bbcsdl/bbcsdl.info b/development/bbcsdl/bbcsdl.info
new file mode 100644
index 0000000000..731f1593e0
--- /dev/null
+++ b/development/bbcsdl/bbcsdl.info
@@ -0,0 +1,12 @@
+PRGNAM="bbcsdl"
+VERSION="1.36a"
+HOMEPAGE="https://www.bbcbasic.co.uk/bbcsdl"
+DOWNLOAD="https://github.com/rtrussell/BBCSDL/archive/ae588d8/BBCSDL-ae588d80bc303897b5da5e108863e0c07fdb30d8.tar.gz \
+ https://github.com/antonioleal/slackbuilds/raw/main/bbcsdl/Box2D231.tar.gz"
+MD5SUM="86571340797c98ee223fd1a387a409c9 \
+ 3d6e27b4b1214432a43244a7bc3e615b"
+DOWNLOAD_x86_64=""
+MD5SUM_x86_64=""
+REQUIRES=""
+MAINTAINER="Antonio Leal"
+EMAIL="antonioleal@yahoo.com"
diff --git a/development/bbcsdl/doinst.sh b/development/bbcsdl/doinst.sh
new file mode 100644
index 0000000000..aea0f894eb
--- /dev/null
+++ b/development/bbcsdl/doinst.sh
@@ -0,0 +1,13 @@
+if [ -x /usr/bin/update-desktop-database ]; then
+ /usr/bin/update-desktop-database -q usr/share/applications >/dev/null 2>&1
+fi
+
+if [ -x /usr/bin/update-mime-database ]; then
+ /usr/bin/update-mime-database usr/share/mime >/dev/null 2>&1
+fi
+
+if [ -e usr/share/icons/hicolor/icon-theme.cache ]; then
+ if [ -x /usr/bin/gtk-update-icon-cache ]; then
+ /usr/bin/gtk-update-icon-cache -f usr/share/icons/hicolor >/dev/null 2>&1
+ fi
+fi
diff --git a/development/bbcsdl/slack-desc b/development/bbcsdl/slack-desc
new file mode 100644
index 0000000000..96ad63f2b4
--- /dev/null
+++ b/development/bbcsdl/slack-desc
@@ -0,0 +1,19 @@
+# HOW TO EDIT THIS FILE:
+# The "handy ruler" below makes it easier to edit a package description.
+# Line up the first '|' above the ':' following the base package name, and
+# the '|' on the right side marks the last column you can put a character in.
+# You must make exactly 11 lines for the formatting to be correct. It's also
+# customary to leave one space after the ':' except on otherwise blank lines.
+
+ |-----handy-ruler------------------------------------------------------|
+bbcsdl: bbcsdl (BBC BASIC for linux)
+bbcsdl:
+bbcsdl: BBC BASIC for SDL 2.0 (BBCSDL) is an entirely free and Open Source
+bbcsdl: cross-platform implementation of BBC BASIC for Windows, MacOS,
+bbcsdl: Linux (x86 CPU only), Raspberry Pi OS (RPi3 or later), Android,
+bbcsdl: iOS or for running in a browser.
+bbcsdl:
+bbcsdl: BBC BASIC is very well documented.
+bbcsdl:
+bbcsdl:
+bbcsdl: